LibreOffice LibreOffice 26.2 SDK API Reference

Included Services | Exported Interfaces | Public Attributes | List of all members
DatabaseImageControl Service Referencepublished

specifies the model of a control used for displaying images stored in a database. More...

`import"DatabaseImageControl.idl";`

Inheritance diagram for DatabaseImageControl:

## Included Services
service | com::sun::star::awt::UnoControlImageControlModel
service | com::sun::star::form::DataAwareControlModel
Included Services inherited from UnoControlImageControlModel
service | com::sun::star::awt::UnoControlModel
Included Services inherited from UnoControlModel
service | com::sun::star::awt::UnoControlDialogElement
| This service is present when the control model is embedded in an UnoControlDialogModel. More...
Included Services inherited from DataAwareControlModel
service | com::sun::star::form::FormControlModel
Included Services inherited from FormControlModel
service | com::sun::star::awt::UnoControlModel
service | com::sun::star::form::FormComponent

## Exported Interfaces
interface | com::sun::star::form::XImageProducerSupplier
| supplies the caller with a com::sun::star::awt::XImageProducer. More...
Exported Interfaces inherited from UnoControlModel
interface | com::sun::star::awt::XControlModel
interface | com::sun::star::lang::XComponent
interface | com::sun::star::beans::XPropertySet
interface | com::sun::star::beans::XMultiPropertySet
interface | com::sun::star::io::XPersistObject
interface | com::sun::star::util::XCloneable
Exported Interfaces inherited from DataAwareControlModel
interface | com::sun::star::form::XBoundComponent
| makes it possible to transfer the data of the model to the connected data field. More...
interface | com::sun::star::form::XLoadListener
| must be implemented in order to recognize when the containing form of the model connects to its data source (loads its data). More...
interface | com::sun::star::form::XReset
| Each DataAwareControlModel should be resettable for setting default values. More...
Exported Interfaces inherited from FormControlModel
interface | com::sun::star::beans::XFastPropertySet
| This optional interface gives an efficient access to all properties at once or an ability to set more than one property at once. More...
interface | com::sun::star::beans::XPropertyState
| This optional interface gives access to the state of the properties, e.g. More...
Exported Interfaces inherited from FormComponent
interface | com::sun::star::form::XFormComponent
| identifies the component as a candidate for being part of a form. More...
interface | com::sun::star::lang::XComponent
| allows life-time control of form components. More...
interface | com::sun::star::container::XNamed
| Each FormComponent must supply a name for identification. More...
interface | com::sun::star::beans::XPropertySet
| gives access to the properties. More...
interface | com::sun::star::io::XPersistObject
| Each FormComponent must be able to be stored into and read from a stream. More...
interface | com::sun::star::beans::XPropertyBag
| allows to associate arbitrary properties with the form component More...
Exported Interfaces inherited from XPropertyBag
interface | com::sun::star::beans::XPropertySet
interface | com::sun::star::beans::XPropertyContainer
interface | com::sun::star::beans::XPropertyAccess

## Public Attributes
boolean | ReadOnly
| indicates if it is possible to change the image being displayed. More...
Public Attributes inherited from UnoControlImageControlModel
com::sun::star::util::Color | BackgroundColor
| specifies the background color (RGB) of the control. More...
short | Border
| specifies the border style of the control. More...
long | BorderColor
| specifies the color of the border, if present More...
boolean | Enabled
| determines whether the control is enabled or disabled. More...
string | HelpText
| specifies the help text of the control. More...
string | HelpURL
| specifies the help URL of the control. More...
string | ImageURL
| specifies a URL to an image to use for the control. More...
com::sun::star::graphic::XGraphic | Graphic
| specifies a graphic to be displayed on the control More...
boolean | Printable
| specifies that the control will be printed with the document. More...
boolean | ScaleImage
| specifies if the image is automatically scaled to the size of the control. More...
short | ScaleMode
| defines how to scale the image More...
boolean | Tabstop
| specifies that the control can be reached with the TAB key. More...
Public Attributes inherited from UnoControlModel
string | DefaultControl
| specifies the service name of the default control for this model. More...
Public Attributes inherited from DataAwareControlModel
string | DataField
| specifies the name of the bound database field. More...
boolean | InputRequired
| determines whether or not input into this field is required, when it is actually bound to a database field. More...
com::sun::star::beans::XPropertySet | BoundField
| references to the cursor field to which the control is bound. More...
com::sun::star::beans::XPropertySet | LabelControl
| references to a control model within the same document which should be used as a label. More...
Public Attributes inherited from FormControlModel
short | ClassId
| specifies the ID for classification of the component. More...
short | TabIndex
| determines the relative taborder of the control associated with the model. More...
string | Tag
| used for additional information. More...
Public Attributes inherited from FormComponent
string | Name
| the name of the component. More...

## Additional Inherited Members
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references. More...
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object. More...
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list. More...
Public Member Functions inherited from XPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValue ([in] string aPropertyName, [in] any aValue) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the value of the property with the specified name. More...
any | getPropertyValue ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
void | addPropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener xListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XPropertyChangeListener to the specified property. More...
void | removePropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XPropertyChangeListener from the listener list. More...
void | addVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XVetoableChangeListener to the specified property with the name PropertyName. More...
void | removeVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XVetoableChangeListener from the listener list. More...
Public Member Functions inherited from XMultiPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValues ([in] sequence< string > aPropertyNames, [in] sequence< any > aValues) raises ( com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the values to the properties with the specified names. More...
sequence< any > | getPropertyValues ([in] sequence< string > aPropertyNames)
void | addPropertiesChangeListener ([in] sequence< string > aPropertyNames, [in] com::sun::star::beans::XPropertiesChangeListener xListener)
| adds an XPropertiesChangeListener to the specified property with the specified names. More...
void | removePropertiesChangeListener ([in] com::sun::star::beans::XPropertiesChangeListener xListener)
| removes an XPropertiesChangeListener from the listener list. More...
void | firePropertiesChangeEvent ([in] sequence< string > aPropertyNames, [in] com::sun::star::beans::XPropertiesChangeListener xListener)
| fires a sequence of PropertyChangeEvents to the specified listener. More...
Public Member Functions inherited from XPersistObject
string | getServiceName ()
| gives the service name of the object More...
void | write ([in] com::sun::star::io::XObjectOutputStream OutStream) raises ( com::sun::star::io::IOException )
| writes all the persistent data of the object to the stream. More...
void | read ([in] com::sun::star::io::XObjectInputStream InStream) raises ( com::sun::star::io::IOException )
| reads all the persistent data of the object from the stream. More...
Public Member Functions inherited from XCloneable
com::sun::star::util::XCloneable | createClone ()
| creates a copy of the object. More...
Public Member Functions inherited from XChild
com::sun::star::uno::XInterface | getParent ()
| grants access to the object containing this content. More...
void | setParent ([in] com::sun::star::uno::XInterface Parent) raises ( com::sun::star::lang::NoSupportException )
| sets the parent to this object. More...
Public Member Functions inherited from XNamed
string | getName ()
void | setName ([in] string aName)
| sets the programmatic name of the object. More...
Public Member Functions inherited from XLoadListener
void | loaded ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object has successfully connected to a datasource. More...
void | unloading ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object is about to be unloaded. More...
void | unloaded ([in] com::sun::star::lang::EventObject aEvent)
| is invoked after the object has disconnected from a datasource. More...
void | reloading ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object is about to be reloaded. More...
void | reloaded ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object has been reloaded. More...
Public Member Functions inherited from XEventListener
void | disposing ([in] com::sun::star::lang::EventObject Source)
| gets called when the broadcaster is about to be disposed. More...
Public Member Functions inherited from XReset
void | reset ()
| resets a component to some default value. More...
void | addResetListener ([in] com::sun::star::form::XResetListener aListener)
| adds the specified listener to receive events related to resetting the component. More...
void | removeResetListener ([in] com::sun::star::form::XResetListener aListener)
| removes the specified listener More...
Public Member Functions inherited from XImageProducerSupplier
com::sun::star::awt::XImageProducer | getImageProducer ()
| accesses the image producer. More...
Protected Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Protected Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references. More...
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object. More...
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list. More...
Protected Member Functions inherited from XPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValue ([in] string aPropertyName, [in] any aValue) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the value of the property with the specified name. More...
any | getPropertyValue ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
void | addPropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener xListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XPropertyChangeListener to the specified property. More...
void | removePropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XPropertyChangeListener from the listener list. More...
void | addVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XVetoableChangeListener to the specified property with the name PropertyName. More...
void | removeVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XVetoableChangeListener from the listener list. More...
Protected Member Functions inherited from XMultiPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValues ([in] sequence< string > aPropertyNames, [in] sequence< any > aValues) raises ( com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the values to the properties with the specified names. More...
sequence< any > | getPropertyValues ([in] sequence< string > aPropertyNames)
void | addPropertiesChangeListener ([in] sequence< string > aPropertyNames, [in] com::sun::star::beans::XPropertiesChangeListener xListener)
| adds an XPropertiesChangeListener to the specified property with the specified names. More...
void | removePropertiesChangeListener ([in] com::sun::star::beans::XPropertiesChangeListener xListener)
| removes an XPropertiesChangeListener from the listener list. More...
void | firePropertiesChangeEvent ([in] sequence< string > aPropertyNames, [in] com::sun::star::beans::XPropertiesChangeListener xListener)
| fires a sequence of PropertyChangeEvents to the specified listener. More...
Protected Member Functions inherited from XPersistObject
string | getServiceName ()
| gives the service name of the object More...
void | write ([in] com::sun::star::io::XObjectOutputStream OutStream) raises ( com::sun::star::io::IOException )
| writes all the persistent data of the object to the stream. More...
void | read ([in] com::sun::star::io::XObjectInputStream InStream) raises ( com::sun::star::io::IOException )
| reads all the persistent data of the object from the stream. More...
Protected Member Functions inherited from XCloneable
com::sun::star::util::XCloneable | createClone ()
| creates a copy of the object. More...
Protected Member Functions inherited from XPropertyContainer
void | addProperty ([in] string Name, [in] short Attributes, [in] any DefaultValue) raises ( com::sun::star::beans::PropertyExistException, com::sun::star::beans::IllegalTypeException, com::sun::star::lang::IllegalArgumentException )
| adds a property to the object. More...
void | removeProperty ([in] string Name) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::NotRemoveableException )
| removes a property from the object. More...
Protected Member Functions inherited from XPropertyAccess
sequence< com::sun::star::beans::PropertyValue > | getPropertyValues ()
void | setPropertyValues ([in] sequence< com::sun::star::beans::PropertyValue > aProps) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the values of given properties. More...
Protected Member Functions inherited from XFastPropertySet
void | setFastPropertyValue ([in] long nHandle, [in] any aValue) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the value to the property with the specified name. More...
any | getFastPropertyValue ([in] long nHandle) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
Protected Member Functions inherited from XPropertyState
com::sun::star::beans::PropertyState | getPropertyState ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException )
sequence< com::sun::star::beans::PropertyState > | getPropertyStates ([in] sequence< string > aPropertyName) raises ( com::sun::star::beans::UnknownPropertyException )
void | setPropertyToDefault ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException )
| Sets the property to default value. More...
any | getPropertyDefault ([in] string aPropertyName) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
Protected Member Functions inherited from XBoundComponent
boolean | commit ()
| commits the content of the component into the data source it is bound to. More...
Protected Member Functions inherited from XUpdateBroadcaster
void | addUpdateListener ([in] com::sun::star::form::XUpdateListener aListener)
| adds the specified listener to receive the events "approveUpdate" and "updated". More...
void | removeUpdateListener ([in] com::sun::star::form::XUpdateListener aListener)
| removes the specified listener. More...
Protected Member Functions inherited from XLoadListener
void | loaded ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object has successfully connected to a datasource. More...
void | unloading ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object is about to be unloaded. More...
void | unloaded ([in] com::sun::star::lang::EventObject aEvent)
| is invoked after the object has disconnected from a datasource. More...
void | reloading ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object is about to be reloaded. More...
void | reloaded ([in] com::sun::star::lang::EventObject aEvent)
| is invoked when the object has been reloaded. More...
Protected Member Functions inherited from XEventListener
void | disposing ([in] com::sun::star::lang::EventObject Source)
| gets called when the broadcaster is about to be disposed. More...
Protected Member Functions inherited from XReset
void | reset ()
| resets a component to some default value. More...
void | addResetListener ([in] com::sun::star::form::XResetListener aListener)
| adds the specified listener to receive events related to resetting the component. More...
void | removeResetListener ([in] com::sun::star::form::XResetListener aListener)
| removes the specified listener More...
Protected Attributes inherited from UnoControlDialogElement
long | Height
| specifies the height of the control. More...
string | Name
| specifies the name of the control. More...
string | PositionX
| specifies the horizontal position of the control. More...
string | PositionY
| specifies the vertical position of the control. More...
long | Step
| specifies the step of the control. More...
short | TabIndex
| specifies the tabindex of the control. More...
string | Tag
| specifies the tag of the control. More...
long | Width
| specifies the width of the control. More...

## Detailed Description

specifies the model of a control used for displaying images stored in a database.

As every com::sun::star::form::DataAwareControlModel, an image control can be bound to a database field. This means that for instance with every record change, the content of the database field is taken, interpreted as image, and displayed in the control.
Unlike other more text-based controls, it does not interpret the content of the field as text or double, but as binary stream (see com::sun::star::sdb::XColumn::getBinaryStream()).

Usually, an image control model can be bound to binary columns only, namely com::sun::star::sdbc::DataType::BINARY, com::sun::star::sdbc::DataType::VARBINARY, com::sun::star::sdbc::DataType::LONGVARBINARY, com::sun::star::sdbc::DataType::OTHER, com::sun::star::sdbc::DataType::LONGVARCHAR

Note that besides taking the image to be displayed from the bound field, there is another option. The com::sun::star::awt::UnoControlImageControlModel::ImageURL property specifies the URL of an image to be displayed. If this property is changed from outside, the respective file is loaded and set as image source.

In a usual data form, the scenario will be as follows:

- There is a DatabaseImageControl as part of the document model, which acts as control model for a com::sun::star::form::control::ImageControl.

- The control is a com::sun::star::awt::XImageConsumer for the com::sun::star::awt::XImageProducer supplied by the model.

- Whenever the form's cursor is positioned on a new record, the column the control model is bound to is examined for a binary data stream. This stream is set as source at the image producer, which notifies it's consumers, which leads to the control displaying the image.

- When the user by some interaction tells the control to contain a new image, this is exchanged by URL. For example, implementations of the control service may allow the user to browse for image. After this, the URL of the image is set as com::sun::star::awt::UnoControlImageControlModel::ImageURL property at the model.
  Now the control loads the image determined by the property value, and starts producing a new data stream, which is displayed by the control (which is a consumer for this stream).
  From now on, the control and thus the database record counts as modified. If the cursor of the form is moved further, the modified record is saved, means the content of the image pointed to by com::sun::star::awt::UnoControlImageControlModel::ImageURL is saved into the column.

## Exported Interfaces

## ◆ com::sun::star::awt::UnoControlImageControlModel

service com::sun::star::awt::UnoControlImageControlModel

## ◆ com::sun::star::form::DataAwareControlModel

service com::sun::star::form::DataAwareControlModel

## Exported Interfaces

## ◆ com::sun::star::form::XImageProducerSupplier

interface com::sun::star::form::XImageProducerSupplier

supplies the caller with a com::sun::star::awt::XImageProducer.

Other components can register as com::sun::star::awt::XImageConsumer at this producer. Then they will be notified of any change in the image to be displayed.

## Member Data Documentation

## ◆ ReadOnly

boolean ReadOnly
| property

indicates if it is possible to change the image being displayed.

The documentation for this service was generated from the following file:

- com/sun/star/form/component/DatabaseImageControl.idl